---
title: Browser Toolbox
slug: Tools/Browser_Toolbox
tags:
  - Debug
  - Firefox
  - JavaScript
---
<div>{{ToolsSidebar}}</div>

<p>The Browser Toolbox enables you to debug add-ons and the browser's own JavaScript code rather than just web pages like the normal <a href="/en-US/docs/Tools_Toolbox">Toolbox</a>.  The Browser Toolbox's context is the whole browser rather than just single page on a single tab.</p>

<div class="note">
<p><em>Note:  If you want to debug a specific add-on that is restartless or SDK-based then try the <a href="/en-US/Add-ons/Add-on_Debugger">Add-on Debugger</a>.  Use the Browser Toolbox for add-ons that are neither.</em></p>
</div>

<h2 id="Enabling_the_Browser_Toolbox" style="line-height: 30px; font-size: 2.14285714285714rem;">Enabling the Browser Toolbox </h2>

<div>
<p>The Browser Toolbox is not enabled by default.  To enable it you need to check the settings "Enable chrome and addon debugging" and "Enable remote debugging".</p>

<p>To do this, open the Developer Tools <a href="/en-US/docs/Tools/Settings">Settings</a>, go to the section "<a href="/en-US/docs/Tools/Settings#Advanced_settings">Advanced Settings</a>", and check the settings "Enable browser chrome and add-on debugging toolboxes" and "Enable remote debugging".</p>

<p><img alt="Developer Tools Settings" src="https://mdn.mozillademos.org/files/16236/settings_for_browser_debugger.png" style="border: 1px solid black; display: block; height: 744px; margin: 0 auto; width: 900px;"></p>
</div>

<h2 id="Opening_the_Browser_Toolbox"><span style="font-size: 2.14285714285714rem;">Opening</span> the Browser Toolbox</h2>

<p><span style="line-height: 1.5;">Open the Browser Toolbox through the </span><span style="line-height: 1.5;">menu button </span><img alt="new fx menu" class="frameless wiki-image" src="https://support.cdn.mozilla.net/media/uploads/gallery/images/2014-01-10-13-08-08-f52b8c.png" style="line-height: 1.5;"><span style="line-height: 1.5;"> and the menu items "Developer" then "Browser Toolbox".</span><span style="line-height: 1.5;"> </span></p>

<p><span style="line-height: 1.5;">You can also open it with the </span><kbd>Ctrl</kbd> + <kbd>Alt</kbd> +<kbd>Shift</kbd> + <kbd>I</kbd>  key combination ( <kbd>Cmd</kbd> + <kbd>Opt</kbd> +<kbd>Shift</kbd> + <kbd>I</kbd> on a Mac).</p>

<p><span style="line-height: 1.5;">You will be presented with a dialog like this (it can be removed by setting the </span><code style="font-style: normal; line-height: 1.5;">devtools.debugger.prompt-connection</code><span style="line-height: 1.5;"> property to false):</span></p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11119/browser-toolbox-warning.png" style="display: block; height: 326px; margin-left: auto; margin-right: auto; width: 600px;">Click OK, and the Browser Toolbox will open in its own window:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11121/browser-toolbox.png" style="display: block; height: 649px; margin-left: auto; margin-right: auto; width: 900px;">You'll be able to inspect the browser's chrome windows and see, and be able to debug, all the JavaScript files loaded by the browser itself and by any add-ons that are running. Altogether you will have access to the following developer tools:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Debugger">Debugger</a>  (<em>Note:  If you want to debug a specific add-on that is restartless or SDK-based then try the <a href="/en-US/Add-ons/Add-on_Debugger">Add-on Debugger</a>.)</em></li>
 <li><a href="/en-US/docs/Tools/Browser_Console">Console</a></li>
 <li><a href="/en-US/docs/Tools/Style_Editor">Style Editor</a></li>
 <li><a href="/en-US/docs/Tools/Profiler">Performance</a></li>
 <li><a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a></li>
 <li><a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a></li>
 <li><a href="/en-US/docs/Tools/Accessibility_inspector">Accessibility Inspector</a></li>
</ul>

<p>You can debug chrome: and about: pages using the normal <a href="/en-US/docs/Tools/Debugger">Debugger</a>, just as if they were ordinary content pages.</p>

<h2 id="Targeting_a_document">Targeting a document</h2>

<p>In the normal toolbox, there's a <a href="/en-US/docs/Tools/Working_with_iframes">button in the toolbar enabling you to target specific iframes in the document</a>. The same button appears in the browser toolbox where it lists all the top-level chrome and content windows as well as any iframes they contain. This enables you to inspect documents in individual chrome windows and popups, as well as in content tabs.</p>

<p>For example, here's what the frame selection popup lists when there are two browser windows open, one with one content tab, and one with two:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11117/browser-toolbox-iframes.png" style="display: block; height: 652px; margin-left: auto; margin-right: auto; width: 900px;"></p>

<h2 id="Debugging_popups">Debugging popups</h2>

<p>It's hard to debug popups, because the browser hides them as soon as you click outside them. There is a way to disable this behavior. Click the toolbox menu and select <strong>Disable popup auto-hide</strong>.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16234/popup_auto-hide.png" style="display: block; height: 249px; margin: 0px auto; width: 350px;"></p>

<p>Now when you open any popup, it will stay open until you press the <kbd>Esc</kbd> key. You can use the Inspector's node picker to select that panel, and examine and modify its content:</p>

<p>{{EmbedYouTube("6edXcunw4jM")}}</p>

<p>You can use the same technique to debug <a href="/en-US/Add-ons/WebExtensions/Debugging#Debugging_popups">popups created by add-ons</a>.</p>

<div class="note">
<p><strong>Note</strong>: This change is not persistent across browser restarts. When you close the browser toolbox, the setting will be cleared.</p>
</div>
